#include "Wire.h"
extern "C" {
#include "utility/twi.h"
} //to umożliwi skanowanie magistrali I2C
// i krótka definicja funkcji  tcsselect():
#define TCAADDR 0x70
void tcaselect(uint8_t i) {
  if (i > 7) return;
  Wire.beginTransmission(TCAADDR);
  Wire.write(1 << i);
  Wire.endTransmission();  }
//a dalej dwie standardowe funkcje:
void setup()  {
 while (!Serial);  delay(1000);
 Wire.begin();  Serial.begin(9600);
 Serial.println("\nskanujemy TCA9548A:");
 for (uint8_t t=0; t<8; t++) {
  tcaselect(t);
  Serial.print("TCA \"wyjście\" numer: ");
  Serial.println(t);
  for(uint8_t addr=0; addr<=127; addr++) {
   if (addr == TCAADDR) continue;
   uint8_t data;
   if(! twi_writeTo(addr, &data, 0, 1, 1)) {
    Serial.print("znalazłem I2C 0x");
    Serial.println(addr,HEX); } } }
  Serial.println("\nkoniec!"); }
void loop()  { }
